<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (147)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
  </head>
  <body>
    <h1 id="bezier-curve">Bezier curve</h1>
    <p>
      Bezier curves are used in computer graphics to draw shapes, for CSS
      animation and in many other places.
    </p>
    <p>
      They are a very simple thing, worth to study once and then feel
      comfortable in the world of vector graphics and advanced animations.
    </p>
    <h2 id="control-points">Control points</h2>
    <p>
      A
      <a href="https://en.wikipedia.org/wiki/B%C3%A9zier_curve">bezier curve</a>
      is defined by control points.
    </p>
    <p>There may be 2, 3, 4 or more.</p>
    <p>For instance, two points curve:</p>
    <p><img src="bezier2.svg" /></p>
    <p>Three points curve:</p>
    <p><img src="bezier3.svg" /></p>
    <p>Four points curve:</p>
    <p><img src="bezier4.svg" /></p>
    <p>If you look closely at these curves, you can immediately notice:</p>
    <ol type="1">
      <li>
        <strong>Points are not always on curve.</strong> That’s perfectly
        normal, later we’ll see how the curve is built.
      </li>
      <li>
        <strong>The curve order equals the number of points minus one</strong>.
        For two points we have a linear curve (that’s a straight line), for
        three points – quadratic curve (parabolic), for four points – cubic
        curve.
      </li>
      <li>
        <p>
          <strong
            >A curve is always inside the
            <a href="https://en.wikipedia.org/wiki/Convex_hull">convex hull</a>
            of control points:</strong
          >
        </p>
        <p><img src="bezier4-e.svg" /> <img src="bezier3-e.svg" /></p>
      </li>
    </ol>
    <p>
      Because of that last property, in computer graphics it’s possible to
      optimize intersection tests. If convex hulls do not intersect, then curves
      do not either. So checking for the convex hulls intersection first can
      give a very fast “no intersection” result. Checking the intersection of
      convex hulls is much easier, because they are rectangles, triangles and so
      on (see the picture above), much simpler figures than the curve.
    </p>
    <p>
      <strong
        >The main value of Bezier curves for drawing – by moving the points the
        curve is changing <em>in intuitively obvious way</em>.</strong
      >
    </p>
    <p>Try to move control points using a mouse in the example below:</p>
    <p>
      [iframe src=“demo.svg?nocpath=1&amp;p=0,0,0.5,0,0.5,1,1,1” height=370]
    </p>
    <p>
      <strong
        >As you can notice, the curve stretches along the tangential lines 1
        -&gt; 2 and 3 -&gt; 4.</strong
      >
    </p>
    <p>
      After some practice it becomes obvious how to place points to get the
      needed curve. And by connecting several curves we can get practically
      anything.
    </p>
    <p>Here are some examples:</p>
    <p>
      <img src="bezier-car.svg" /> <img src="bezier-letter.svg" />
      <img src="bezier-vase.svg" />
    </p>
    <h2 id="de-casteljaus-algorithm">De Casteljau’s algorithm</h2>
    <p>
      There’s a mathematical formula for Bezier curves, but let’s cover it a bit
      later, because
      <a href="https://en.wikipedia.org/wiki/De_Casteljau%27s_algorithm"
        >De Casteljau’s algorithm</a
      >
      is identical to the mathematical definition and visually shows how it is
      constructed.
    </p>
    <p>First let’s see the 3-points example.</p>
    <p>Here’s the demo, and the explanation follow.</p>
    <p>
      Control points (1,2 and 3) can be moved by the mouse. Press the “play”
      button to run it.
    </p>
    <p>[iframe src=“demo.svg?p=0,0,0.5,1,1,0&amp;animate=1” height=370]</p>
    <p>
      <strong
        >De Casteljau’s algorithm of building the 3-point bezier curve:</strong
      >
    </p>
    <ol type="1">
      <li>
        Draw control points. In the demo above they are labeled: <code>1</code>,
        <code>2</code>, <code>3</code>.
      </li>
      <li>
        Build segments between control points 1 -&gt; 2 -&gt; 3. In the demo
        above they are <span style="color: #825e28">brown</span>.
      </li>
      <li>
        <p>
          The parameter <code>t</code> moves from <code>0</code> to
          <code>1</code>. In the example above the step <code>0.05</code> is
          used: the loop goes over <code>0, 0.05, 0.1, 0.15, ... 0.95, 1</code>.
        </p>
        <p>For each of these values of <code>t</code>:</p>
        <ul>
          <li>
            <p>
              On each <span style="color: #825e28">brown</span> segment we take
              a point located on the distance proportional to
              <code>t</code> from its beginning. As there are two segments, we
              have two points.
            </p>
            <p>
              For instance, for <code>t=0</code> – both points will be at the
              beginning of segments, and for <code>t=0.25</code> – on the 25% of
              segment length from the beginning, for <code>t=0.5</code> –
              50%(the middle), for <code>t=1</code> – in the end of segments.
            </p>
          </li>
          <li>
            <p>
              Connect the points. On the picture below the connecting segment is
              painted <span style="color: #167490">blue</span>.
            </p>
          </li>
        </ul>
      </li>
    </ol>
    <table>
      <thead>
        <tr class="header">
          <th>For <code>t=0.25</code></th>
          <th>For <code>t=0.5</code></th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><img src="bezier3-draw1.svg" /></td>
          <td><img src="bezier3-draw2.svg" /></td>
        </tr>
      </tbody>
    </table>
    <ol start="4" type="1">
      <li>
        <p>
          Now in the <span style="color: #167490">blue</span> segment take a
          point on the distance proportional to the same value of
          <code>t</code>. That is, for <code>t=0.25</code> (the left picture) we
          have a point at the end of the left quarter of the segment, and for
          <code>t=0.5</code> (the right picture) – in the middle of the segment.
          On pictures above that point is <span style="color: red">red</span>.
        </p>
      </li>
      <li>
        <p>
          As <code>t</code> runs from <code>0</code> to <code>1</code>, every
          value of <code>t</code> adds a point to the curve. The set of such
          points forms the Bezier curve. It’s red and parabolic on the pictures
          above.
        </p>
      </li>
    </ol>
    <p>That was a process for 3 points. But the same is for 4 points.</p>
    <p>The demo for 4 points (points can be moved by a mouse):</p>
    <p>
      [iframe src=“demo.svg?p=0,0,0.5,0,0.5,1,1,1&amp;animate=1” height=370]
    </p>
    <p>The algorithm for 4 points:</p>
    <ul>
      <li>
        Connect control points by segments: 1 -&gt; 2, 2 -&gt; 3, 3 -&gt; 4.
        There will be 3 <span style="color: #825e28">brown</span> segments.
      </li>
      <li>
        For each <code>t</code> in the interval from <code>0</code> to
        <code>1</code>:
        <ul>
          <li>
            We take points on these segments on the distance proportional to
            <code>t</code> from the beginning. These points are connected, so
            that we have two <span style="color: #0a0">green segments</span>.
          </li>
          <li>
            On these segments we take points proportional to <code>t</code>. We
            get one <span style="color: #167490">blue segment</span>.
          </li>
          <li>
            On the blue segment we take a point proportional to <code>t</code>.
            On the example above it’s <span style="color: red">red</span>.
          </li>
        </ul>
      </li>
      <li>These points together form the curve.</li>
    </ul>
    <p>
      The algorithm is recursive and can be generalized for any number of
      control points.
    </p>
    <p>Given N of control points:</p>
    <ol type="1">
      <li>We connect them to get initially N-1 segments.</li>
      <li>
        Then for each <code>t</code> from <code>0</code> to <code>1</code>, we
        take a point on each segment on the distance proportional to
        <code>t</code> and connect them. There will be N-2 segments.
      </li>
      <li>Repeat step 2 until there is only one point.</li>
    </ol>
    <p>These points make the curve.</p>
    <pre
      class="online"
    ><code>**Run and pause examples to clearly see the segments and how the curve is built.**</code></pre>
    <p>A curve that looks like <code>y=1/t</code>:</p>
    <p>
      [iframe src=“demo.svg?p=0,0,0,0.75,0.25,1,1,1&amp;animate=1” height=370]
    </p>
    <p>Zig-zag control points also work fine:</p>
    <p>
      [iframe src=“demo.svg?p=0,0,1,0.5,0,0.5,1,1&amp;animate=1” height=370]
    </p>
    <p>Making a loop is possible:</p>
    <p>
      [iframe src=“demo.svg?p=0,0,1,0.5,0,1,0.5,0&amp;animate=1” height=370]
    </p>
    <p>A non-smooth Bezier curve (yeah, that’s possible too):</p>
    <p>[iframe src=“demo.svg?p=0,0,1,1,0,1,1,0&amp;animate=1” height=370]</p>
    <pre
      class="online"
    ><code>If there&#39;s something unclear in the algorithm description, please look at the live examples above to see how
the curve is built.</code></pre>
    <p>
      As the algorithm is recursive, we can build Bezier curves of any order,
      that is: using 5, 6 or more control points. But in practice many points
      are less useful. Usually we take 2-3 points, and for complex lines glue
      several curves together. That’s simpler to develop and calculate.
    </p>
    <p>
      ```smart header=“How to draw a curve <em>through</em> given points?” To
      specify a Bezier curve, control points are used. As we can see, they are
      not on the curve, except the first and the last ones.
    </p>
    <p>
      Sometimes we have another task: to draw a curve
      <em>through several points</em>, so that all of them are on a single
      smooth curve. That task is called
      <a href="https://en.wikipedia.org/wiki/Interpolation">interpolation</a>,
      and here we don’t cover it.
    </p>
    <p>
      There are mathematical formulas for such curves, for instance
      <a href="https://en.wikipedia.org/wiki/Lagrange_polynomial"
        >Lagrange polynomial</a
      >. In computer graphics
      <a href="https://en.wikipedia.org/wiki/Spline_interpolation"
        >spline interpolation</a
      >
      is often used to build smooth curves that connect many points. ```
    </p>
    <h2 id="maths">Maths</h2>
    <p>A Bezier curve can be described using a mathematical formula.</p>
    <p>
      As we saw – there’s actually no need to know it, most people just draw the
      curve by moving points with a mouse. But if you’re into maths – here it
      is.
    </p>
    <p>
      Given the coordinates of control points <code>P<sub>i</sub></code
      >: the first control point has coordinates
      <code>P<sub>1</sub> = (x<sub>1</sub>, y<sub>1</sub>)</code>, the second:
      <code>P<sub>2</sub> = (x<sub>2</sub>, y<sub>2</sub>)</code>, and so on,
      the curve coordinates are described by the equation that depends on the
      parameter <code>t</code> from the segment <code>[0,1]</code>.
    </p>
    <ul>
      <li>
        <p>The formula for a 2-points curve:</p>
        <p>
          <code>P = (1-t)P<sub>1</sub> + tP<sub>2</sub></code>
        </p>
      </li>
      <li>
        <p>For 3 control points:</p>
        <p>
          <code
            >P = (1−t)<sup>2</sup>P<sub>1</sub> + 2(1−t)tP<sub>2</sub> +
            t<sup>2</sup>P<sub>3</sub></code
          >
        </p>
      </li>
      <li>
        <p>For 4 control points:</p>
        <p>
          <code
            >P = (1−t)<sup>3</sup>P<sub>1</sub> + 3(1−t)<sup>2</sup>tP<sub
              >2</sub
            >
            +3(1−t)t<sup>2</sup>P<sub>3</sub> + t<sup>3</sup>P<sub>4</sub></code
          >
        </p>
      </li>
    </ul>
    <p>
      These are vector equations. In other words, we can put <code>x</code> and
      <code>y</code> instead of <code>P</code> to get corresponding coordinates.
    </p>
    <p>
      For instance, the 3-point curve is formed by points
      <code>(x,y)</code> calculated as:
    </p>
    <ul>
      <li>
        <code
          >x = (1−t)<sup>2</sup>x<sub>1</sub> + 2(1−t)tx<sub>2</sub> +
          t<sup>2</sup>x<sub>3</sub></code
        >
      </li>
      <li>
        <code
          >y = (1−t)<sup>2</sup>y<sub>1</sub> + 2(1−t)ty<sub>2</sub> +
          t<sup>2</sup>y<sub>3</sub></code
        >
      </li>
    </ul>
    <p>
      Instead of
      <code
        >x<sub>1</sub>, y<sub>1</sub>, x<sub>2</sub>, y<sub>2</sub>,
        x<sub>3</sub>, y<sub>3</sub></code
      >
      we should put coordinates of 3 control points, and then as
      <code>t</code> moves from <code>0</code> to <code>1</code>, for each value
      of <code>t</code> we’ll have <code>(x,y)</code> of the curve.
    </p>
    <p>
      For instance, if control points are <code>(0,0)</code>,
      <code>(0.5, 1)</code> and <code>(1, 0)</code>, the equations become:
    </p>
    <ul>
      <li>
        <code
          >x = (1−t)<sup>2</sup> _ 0 + 2(1−t)t _ 0.5 + t<sup>2</sup> * 1 =
          (1-t)t + t<sup>2</sup> = t</code
        >
      </li>
      <li>
        <code
          >y = (1−t)<sup>2</sup> _ 0 + 2(1−t)t _ 1 + t<sup>2</sup> * 0 = 2(1-t)t
          = –2t<sup>2</sup> + 2t</code
        >
      </li>
    </ul>
    <p>
      Now as <code>t</code> runs from <code>0</code> to <code>1</code>, the set
      of values <code>(x,y)</code> for each <code>t</code> forms the curve for
      such control points.
    </p>
    <h2 id="summary">Summary</h2>
    <p>Bezier curves are defined by their control points.</p>
    <p>We saw two definitions of Bezier curves:</p>
    <ol type="1">
      <li>Using a drawing process: De Casteljau’s algorithm.</li>
      <li>Using a mathematical formulas.</li>
    </ol>
    <p>Good properties of Bezier curves:</p>
    <ul>
      <li>We can draw smooth lines with a mouse by moving control points.</li>
      <li>Complex shapes can be made of several Bezier curves.</li>
    </ul>
    <p>Usage:</p>
    <ul>
      <li>
        In computer graphics, modeling, vector graphic editors. Fonts are
        described by Bezier curves.
      </li>
      <li>
        In web development – for graphics on Canvas and in the SVG format. By
        the way, “live” examples above are written in SVG. They are actually a
        single SVG document that is given different points as parameters. You
        can open it in a separate window and see the source:
        <a href="demo.svg?p=0,0,1,0.5,0,0.5,1,1&amp;animate=1">demo.svg</a>.
      </li>
      <li>In CSS animation to describe the path and speed of animation.</li>
    </ul>
  </body>
</html>
